/*
 * ATTENTION: The "eval" devtool has been used (maybe by default in mode: "development").
 * This devtool is neither made for production nor for readable output files.
 * It uses "eval()" calls to create a separate source file in the browser devtools.
 * If you are trying to read the output file, select a different devtool (https://webpack.js.org/configuration/devtool/)
 * or disable the default devtool with "devtool: false".
 * If you are looking for production-ready output files, see mode: "production" (https://webpack.js.org/configuration/mode/).
 */
/******/ (function() { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "./src/js/index.js":
/*!*************************!*\
  !*** ./src/js/index.js ***!
  \*************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _modules_changeDropdownValue__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./modules/changeDropdownValue */ \"./src/js/modules/changeDropdownValue.js\");\n/* harmony import */ var _modules_logInModal__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./modules/logInModal */ \"./src/js/modules/logInModal.js\");\n\n\n\n\n\n\n//# sourceURL=webpack://step_project_cards/./src/js/index.js?");

/***/ }),

/***/ "./src/js/modules/changeDropdownValue.js":
/*!***********************************************!*\
  !*** ./src/js/modules/changeDropdownValue.js ***!
  \***********************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

eval("__webpack_require__.r(__webpack_exports__);\nfunction changeDropdownValue(\n    selectItemsArray,\n    isOpenModal = false,\n    editModalDoctor = false,\n    data = {}\n) {\n    if (editModalDoctor) {\n        renderDoctorInputs(editModalDoctor, data);\n    }\n    for (let item of selectItemsArray) {\n        item.addEventListener(\"click\", (event) => {\n            const ariaLabelledBy =\n                item.parentElement.parentElement.getAttribute(\n                    \"aria-labelledby\"\n                );\n            const eventTarget = event.target.innerText;\n            const targetButton = document.querySelector(`#${ariaLabelledBy}`);\n            targetButton.innerText = eventTarget;\n            if (isOpenModal) {\n                const inputs = document.querySelectorAll(\".form__input\");\n                const selectDoctors = document.querySelector(\n                    \"#visitModalDropdownMenuDoctors\"\n                );\n                selectDoctors.style.borderColor = \"\";\n                inputs.forEach((e) => {\n                    e.style.borderColor = \"\";\n                });\n                renderDoctorInputs(item.textContent);\n            }\n        });\n    }\n}\n\nfunction renderDoctorInputs(\n    doctor,\n    { lastVisit, pressure, lastPressure, age } = {}\n) {\n    const inputToRemove = document.querySelectorAll(\".inserted-field\");\n    if (inputToRemove) {\n        inputToRemove.forEach((e) => {\n            e.remove();\n        });\n    }\n    const modalBody = document.querySelector(\".modal-body\");\n    if (doctor === \"Dentist\") {\n        modalBody.insertAdjacentHTML(\n            \"beforeend\",\n            `<input type=\"text\"\n            name=\"last visit date\"\n            class=\"form__input inserted-field\" id=\"userLastVisit\"\n            placeholder=\"Last visit date\" value=\"${\n                lastVisit ? lastVisit : \"\"\n            }\">`\n        );\n    } else if (doctor === \"Cardiologist\") {\n        modalBody.insertAdjacentHTML(\n            \"beforeend\",\n            `<input type=\"text\"\n            name=\"pressure\"\n            class=\"form__input inserted-field\" id=\"userPressure\"\n            placeholder=\"Pressure\" value=\"${pressure ? pressure : \"\"}\">\n\n            <input type=\"text\"\n            name=\"age\"\n            class=\"form__input inserted-field\" id=\"userAge\"\n            placeholder=\"Age\" value=\"${age ? age : \"\"}\">\n\n            <textarea class=\"form__input inserted-field\" \n            placeholder=\"Past cardiovascular diseases\"\n            id=\"userLastPressure\"\n            rows=\"3\">${lastPressure ? lastPressure : \"\"}</textarea>`\n        );\n    } else if (doctor === \"Physician\") {\n        modalBody.insertAdjacentHTML(\n            \"beforeend\",\n            `<input type=\"text\"\n            name=\"age\"\n            class=\"form__input inserted-field\" id=\"userAge\"\n            placeholder=\"Age\" value=\"${age ? age : \"\"}\">`\n        );\n    }\n}\n\nconst selectItemsArray = document.querySelectorAll(\n    \".options__input-container .options__dropdown-item\"\n);\nchangeDropdownValue(selectItemsArray);\n/* harmony default export */ __webpack_exports__[\"default\"] = (changeDropdownValue);\n\n\n//# sourceURL=webpack://step_project_cards/./src/js/modules/changeDropdownValue.js?");

/***/ }),

/***/ "./src/js/modules/element.js":
/*!***********************************!*\
  !*** ./src/js/modules/element.js ***!
  \***********************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

eval("__webpack_require__.r(__webpack_exports__);\nclass Element{\n  createElement(elemType, className, text, id){\n    const element = document.createElement(elemType);\n    if(text) {\n      element.textContent = text;\n    }\n    element.classList.add(...className);\n    if(id){\n      element.id = id;\n    }\n    return element\n  }\n  \n}\n\n/* harmony default export */ __webpack_exports__[\"default\"] = (Element);\n\n//# sourceURL=webpack://step_project_cards/./src/js/modules/element.js?");

/***/ }),

/***/ "./src/js/modules/handler.js":
/*!***********************************!*\
  !*** ./src/js/modules/handler.js ***!
  \***********************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _element__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./element */ \"./src/js/modules/element.js\");\n/* harmony import */ var _modal__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./modal */ \"./src/js/modules/modal.js\");\n/* harmony import */ var _request__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./request */ \"./src/js/modules/request.js\");\n/* harmony import */ var _visitModal__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./visitModal */ \"./src/js/modules/visitModal.js\");\n/* harmony import */ var _moreInfoModal__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./moreInfoModal */ \"./src/js/modules/moreInfoModal.js\");\n\n\n\n\n\n\n\nclass Handler extends _element__WEBPACK_IMPORTED_MODULE_0__[\"default\"] {\n    constructor() {\n        super();\n        this.container = document.querySelector(\".desk__items-container\");\n        this.handlerButtons();\n    }\n    handlerButtons() {\n        this.container.addEventListener(\"click\", (event) => {\n            event.preventDefault();\n            this.item = event.target;\n            if (this.item.tagName !== \"BUTTON\") return;\n            this.itemId = this.item.closest(\".item\").dataset.id;\n            this.deleteItem();\n            this.moreInfoBtn();\n            this.editBtn();\n        });\n    }\n    values() {\n        this.wrapper = this.item.closest(\".item__container\");\n        this.name = this.wrapper.querySelector(\".item__name\").innerText;\n        this.doctor =\n            this.wrapper.querySelector(\".item__doctor span\").innerText;\n        this.status =\n            this.wrapper.querySelector(\".item__status span\").innerText;\n        this.description = this.wrapper.querySelector(\n            \".content-extra__description\"\n        ).innerText;\n        this.problem = this.wrapper.querySelector(\n            \".content-extra__problem\"\n        ).innerText;\n    }\n    currentDoctorValues() {\n        if (this.doctor === \"Dentist\") {\n            this.lastVisit = this.wrapper.querySelector(\n                \".content-extra__lastVisit\"\n            ).innerText;\n            return {\n                id: this.itemId,\n                status: this.status,\n                name: this.name,\n                doctor: this.doctor,\n                problem: this.problem,\n                description: this.description,\n                lastVisit: this.lastVisit,\n            };\n        }\n        if (this.doctor === \"Cardiologist\") {\n            this.pressure = this.wrapper.querySelector(\n                \".content-extra__pressure\"\n            ).innerText;\n            this.lastPressure = this.wrapper.querySelector(\n                \".content-extra__lastPressure\"\n            ).innerText;\n            this.age = this.wrapper.querySelector(\n                \".content-extra__age\"\n            ).innerText;\n            return {\n                id: this.itemId,\n                name: this.name,\n                doctor: this.doctor,\n                status: this.status,\n                problem: this.problem,\n                description: this.description,\n                pressure: this.pressure,\n                lastPressure: this.lastPressure,\n                age: this.age,\n            };\n        }\n        if (this.doctor === \"Physician\") {\n            this.age = this.wrapper.querySelector(\n                \".content-extra__age\"\n            ).innerText;\n            return {\n                id: this.itemId,\n                status: this.status,\n                name: this.name,\n                doctor: this.doctor,\n                problem: this.problem,\n                description: this.description,\n                age: this.age,\n            };\n        }\n    }\n    deleteItem() {\n        if (!this.item.dataset.del) return;\n        (0,_request__WEBPACK_IMPORTED_MODULE_2__[\"default\"])({\n            url: `https://ajax.test-danit.com/api/v2/cards/${this.itemId}`,\n            options: { method: \"DELETE\" },\n        });\n        this.item.closest(\".col\").remove();\n    }\n    moreInfoBtn() {\n        if (!this.item.dataset.moreinfo) return;\n        this.values();\n        const values = this.currentDoctorValues();\n        const moreInfoModal = new _moreInfoModal__WEBPACK_IMPORTED_MODULE_4__[\"default\"](\"More Info\", values);\n        moreInfoModal.render();\n    }\n    editBtn() {\n        if (!this.item.dataset.edit) return;\n        const editModal = new _visitModal__WEBPACK_IMPORTED_MODULE_3__[\"default\"](\"Edit\");\n        this.values();\n        const {\n            name,\n            status,\n            doctor,\n            problem,\n            id,\n            description,\n            lastVisit,\n            pressure,\n            lastPressure,\n            age,\n        } = this.currentDoctorValues();\n        editModal.render({\n            name,\n            status,\n            doctor,\n            problem,\n            id,\n            description,\n            lastVisit,\n            pressure,\n            lastPressure,\n            age,\n        });\n    }\n}\n\n/* harmony default export */ __webpack_exports__[\"default\"] = (Handler);\n\n\n//# sourceURL=webpack://step_project_cards/./src/js/modules/handler.js?");

/***/ }),

/***/ "./src/js/modules/logInModal.js":
/*!**************************************!*\
  !*** ./src/js/modules/logInModal.js ***!
  \**************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export */ __webpack_require__.d(__webpack_exports__, {\n/* harmony export */   \"LogInModal\": function() { return /* binding */ LogInModal; },\n/* harmony export */   \"loadPatients\": function() { return /* binding */ loadPatients; }\n/* harmony export */ });\n/* harmony import */ var _modal__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./modal */ \"./src/js/modules/modal.js\");\n/* harmony import */ var _handler__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./handler */ \"./src/js/modules/handler.js\");\n/* harmony import */ var _visit__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./visit */ \"./src/js/modules/visit.js\");\n/* harmony import */ var _request__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./request */ \"./src/js/modules/request.js\");\n/* harmony import */ var _search__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./search */ \"./src/js/modules/search.js\");\n/* harmony import */ var _visitModal__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./visitModal */ \"./src/js/modules/visitModal.js\");\n\n\n\n\n\n\n\nasync function loadPatients() {\n    const response = await (0,_request__WEBPACK_IMPORTED_MODULE_3__[\"default\"])({\n        url: \"https://ajax.test-danit.com/api/v2/cards\",\n    });\n    const data = await response.json();\n    console.log(data);\n    data.forEach(\n        ({\n            name,\n            status,\n            doctor,\n            problem,\n            id,\n            description,\n            lastVisit,\n            pressure,\n            lastPressure,\n            age,\n        }) => {\n            const user = new _visit__WEBPACK_IMPORTED_MODULE_2__[\"default\"]({\n                name,\n                status,\n                doctor,\n                problem,\n                id,\n                description,\n                lastVisit,\n                pressure,\n                lastPressure,\n                age,\n            });\n            user.createCard();\n        }\n    );\n}\n\nfunction checkAccess() {\n    const logInName = document.getElementById(\"log-in__name\");\n    const logInPassword = document.getElementById(\"log-in__password\");\n    let flag = false;\n    const accessGranted = [{ name: \"danit\", password: \"thebest\" }];\n\n    accessGranted.forEach((e) => {\n        const { name: accessName, password: accessPassword } = e;\n        if (\n            accessName.toLocaleLowerCase() ===\n                logInName.value.toLocaleLowerCase() &&\n            accessPassword === logInPassword.value\n        ) {\n            flag = true;\n            return;\n        } else {\n            logInName.style.borderColor = \"red\";\n            logInPassword.style.borderColor = \"red\";\n        }\n    });\n    return flag;\n}\n\nfunction callModal() {\n    const visitBtn = document.getElementById(\"create-visit-btn\");\n    const basicModal = new _modal__WEBPACK_IMPORTED_MODULE_0__[\"default\"]();\n    const visitModal = new _visitModal__WEBPACK_IMPORTED_MODULE_5__[\"default\"](\"Create visit\");\n    basicModal.render();\n    visitBtn.addEventListener(\"click\", () => {\n        visitModal.render();\n    });\n}\n\nclass LogInModal extends _modal__WEBPACK_IMPORTED_MODULE_0__[\"default\"] {\n    render() {\n        const modalBody = document.querySelector(\".form__body\");\n        const closeBtn = document.querySelector(\".form__btn-close\");\n        const modalDialog = document.querySelector(\"#exampleModal\");\n        const logInInputs = `<input\n        type=\"text\"\n        name=\"name\"\n        class=\"form__input\"\n        placeholder=\"Enter your name\"\n        id=\"log-in__name\"\n    />\n    <input\n        type=\"password\"\n        name=\"password\"\n        class=\"form__input\"\n        placeholder=\"Enter your password\"\n        id=\"log-in__password\"\n    />\n    <label class=\"form__checkbox-text\">\n        <input\n            type=\"checkbox\"\n            name=\"checkbox\"\n            class=\"form__checkbox\"\n        />\n        Remember me\n    </label>`;\n\n        modalBody.insertAdjacentHTML(\"afterbegin\", logInInputs);\n        closeBtn.addEventListener(\"click\", this.clearInputs);\n\n        modalDialog.addEventListener(\"click\", (e) => {\n            if (e.target.id === \"exampleModal\") {\n                this.clearInputs();\n            }\n        });\n    }\n    getLogIn() {\n        const formSubmitBtn = document.querySelector(\".form__submit-bnt\");\n        formSubmitBtn.addEventListener(\"click\", () => {\n            if (!checkAccess()) {\n                return;\n            }\n            const logInCheckbox = document.querySelector(\".form__checkbox\");\n            super.hideModal();\n            logInBtn.insertAdjacentHTML(\"afterend\", createVisitBtn);\n            logInBtn.remove();\n\n            if (logInCheckbox.checked) {\n                localStorage.setItem(\"rememberMe\", \"true\");\n            }\n            loadPatients();\n            const handler = new _handler__WEBPACK_IMPORTED_MODULE_1__[\"default\"]();\n            (0,_search__WEBPACK_IMPORTED_MODULE_4__[\"default\"])();\n            callModal();\n        });\n    }\n    hideModal() {\n        super.hideModal();\n    }\n    clearInputs() {\n        super.clearInputs();\n        const checkbox = document.querySelector(\".form__checkbox-text\");\n        setTimeout(function () {\n            checkbox.remove();\n        }, 500);\n    }\n}\nwindow.addEventListener(\"load\", () => {\n    if (localStorage.getItem(\"rememberMe\")) {\n        logInBtn.insertAdjacentHTML(\"afterend\", createVisitBtn);\n        logInBtn.remove();\n        loadPatients();\n        const handler = new _handler__WEBPACK_IMPORTED_MODULE_1__[\"default\"]();\n        (0,_search__WEBPACK_IMPORTED_MODULE_4__[\"default\"])();\n        callModal();\n        return;\n    }\n    const modal = new _modal__WEBPACK_IMPORTED_MODULE_0__[\"default\"](\"Log In\");\n    modal.render();\n    const logInModal = new LogInModal();\n    logInModal.getLogIn();\n    logInBtn.addEventListener(\"click\", () => {\n        logInModal.render();\n    });\n});\n\nconst createVisitBtn = `<button id=\"create-visit-btn\"\n    class=\"header__button\" data-bs-toggle=\"modal\" \n    data-bs-target=\"#exampleModal\"\n    >Create Visit</button>`;\nconst logInBtn = document.getElementById(\"log-in-btn\");\n\n\n\n\n//# sourceURL=webpack://step_project_cards/./src/js/modules/logInModal.js?");

/***/ }),

/***/ "./src/js/modules/modal.js":
/*!*********************************!*\
  !*** ./src/js/modules/modal.js ***!
  \*********************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

eval("__webpack_require__.r(__webpack_exports__);\nclass Modal {\n    constructor(modalName) {\n        this.modalName = modalName;\n    }\n    render() {\n        const modalDiv = `<div class=\"modal fade\" id=\"exampleModal\" tabindex=\"-1\" aria-labelledby=\"exampleModalLabel\" aria-hidden=\"true\">\n        <!-- Modal -->\n        <div class=\"modal-dialog modal-dialog-centered\">\n            <div class=\"modal-content form\">\n                <div class=\"modal-header form__header\">\n                    <div class=\"form__green-box\"></div>\n                    <h5 class=\"modal-title\" id=\"exampleModalLabel\">\n                        ${this.modalName}\n                    </h5>\n                    <button type=\"button\" class=\"btn-close form__btn-close\" data-bs-dismiss=\"modal\" aria-label=\"Close\"></button>\n                </div>\n                <div class=\"modal-body form__body\"></div>\n                <div class=\"modal-footer form__footer\">\n                    <button type=\"submit\" class=\"btn btn-lg form__submit-bnt\">\n                        ${this.modalName}\n                    </button>\n                </div>\n            </div>\n        </div>\n    </div>`;\n        document.body.insertAdjacentHTML(\"afterbegin\", modalDiv);\n\n        const closeBtn = document.querySelector(\".form__btn-close\");\n        closeBtn.addEventListener(\"click\", this.clearInputs);\n    }\n    hideModal() {\n        const modalForm = document.getElementById(\"exampleModal\");\n        const modalBg = document.querySelector(\".modal-backdrop\");\n\n        modalForm.classList.remove(\"show\");\n        setTimeout(function () {\n            modalForm.remove();\n        }, 500);\n\n        document.body.classList.remove(\"modal-open\");\n        document.body.style.overflow = \"\";\n        document.body.style.paddingRight = \"\";\n        if (modalBg) {\n            modalBg.remove();\n        }\n    }\n    clearInputs() {\n        setTimeout(function () {\n            const inputs = document.querySelectorAll(\".form__input\");\n            inputs.forEach((e) => e.remove());\n        }, 500);\n    }\n}\n/* harmony default export */ __webpack_exports__[\"default\"] = (Modal);\n\n\n//# sourceURL=webpack://step_project_cards/./src/js/modules/modal.js?");

/***/ }),

/***/ "./src/js/modules/moreInfoModal.js":
/*!*****************************************!*\
  !*** ./src/js/modules/moreInfoModal.js ***!
  \*****************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _modal__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./modal */ \"./src/js/modules/modal.js\");\n\n\nclass MoreInfoModal extends _modal__WEBPACK_IMPORTED_MODULE_0__[\"default\"] {\n    constructor(\n        modalName,\n        {\n            name,\n            status,\n            doctor,\n            problem,\n            id,\n            description,\n            lastVisit,\n            pressure,\n            lastPressure,\n            age,\n        }\n    ) {\n        super(modalName);\n        this.modalName = modalName;\n        this.name = name;\n        this.status = status;\n        this.doctor = doctor;\n        this.problem = problem;\n        this.id = id;\n        this.description = description;\n        this.lastVisit = lastVisit;\n        this.pressure = pressure;\n        this.lastPressure = lastPressure;\n        this.age = age;\n    }\n    render() {\n        const modalBody = document.querySelector(\".form__body\");\n        const submitBtn = document.querySelector(\".form__submit-bnt\");\n        const modalTitle = document.querySelector(\"#exampleModalLabel\");\n        const closeBtn = document.querySelector(\".form__btn-close\");\n        const modalDialog = document.querySelector(\"#exampleModal\");\n        modalTitle.textContent = `${this.modalName}`;\n        submitBtn.style.display = \"none\";\n        modalBody.insertAdjacentHTML(\n            \"beforeend\",\n            `<p class=\"form__input\">Doctor: ${this.doctor}</p>\n            <p class=\"form__input\">The purpose of visit: ${this.problem}</p>\n            <p class=\"form__input\">Short description: ${this.description}</p>\n            <p class=\"form__input\">Name: ${this.name}</p>`\n        );\n        if (this.doctor === \"Dentist\") {\n            modalBody.insertAdjacentHTML(\n                \"beforeend\",\n                `<p class=\"form__input\">Last visit date: ${this.lastVisit}</p>`\n            );\n        } else if (this.doctor === \"Physician\") {\n            modalBody.insertAdjacentHTML(\n                \"beforeend\",\n                `<p class=\"form__input\">Age: ${this.age}</p>`\n            );\n        } else if (this.doctor === \"Cardiologist\") {\n            modalBody.insertAdjacentHTML(\n                \"beforeend\",\n                `<p class=\"form__input\">Pressure: ${this.pressure}</p>\n                <p class=\"form__input\">Age: ${this.age}</p>\n                <p class=\"form__input\">Past cardiovascular diseases: ${this.lastPressure}</p>`\n            );\n        }\n        if (this.status === \"Open\") {\n            modalBody.insertAdjacentHTML(\n                \"beforeend\",\n                `<button class=\"form__input form__status-btn \n                form__status-btn--green form__status-btn--cursor-default\" \n                id=\"status-btn\" data-status=\"Open\">Status: Open</button>`\n            );\n        } else if (this.status === \"Done\") {\n            modalBody.insertAdjacentHTML(\n                \"beforeend\",\n                `<button class=\"form__input form__status-btn form__status-btn--red \n                form__status-btn--cursor-default\" id=\"status-btn\" \n                data-status=\"Done\">Status: Done</button>`\n            );\n        }\n        closeBtn.addEventListener(\"click\", this.clearInputs);\n        modalDialog.addEventListener(\"click\", (e) => {\n            if (e.target.id === \"exampleModal\") {\n                this.clearInputs();\n            }\n        });\n    }\n    clearInputs() {\n        super.clearInputs();\n        const submitBtn = document.querySelector(\".form__submit-bnt\");\n        setTimeout(function () {\n            submitBtn.style.display = \"\";\n        }, 500);\n    }\n}\n\n/* harmony default export */ __webpack_exports__[\"default\"] = (MoreInfoModal);\n\n\n//# sourceURL=webpack://step_project_cards/./src/js/modules/moreInfoModal.js?");

/***/ }),

/***/ "./src/js/modules/request.js":
/*!***********************************!*\
  !*** ./src/js/modules/request.js ***!
  \***********************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

eval("__webpack_require__.r(__webpack_exports__);\nconst request =  ({url, data, options = {}}) =>{\n  const key = \"b79f9492-9e9f-4a4b-81ba-12700a39115e\" ;\n  return fetch(url, {\n    method: \"GET\",\n    ...options,\n    headers: {\n      'Content-Type': 'application/json',\n      'Authorization': `Bearer ${key}`\n    },\n    body: JSON.stringify(data)\n  })\n}\n\n/* harmony default export */ __webpack_exports__[\"default\"] = (request);\n\n//# sourceURL=webpack://step_project_cards/./src/js/modules/request.js?");

/***/ }),

/***/ "./src/js/modules/search.js":
/*!**********************************!*\
  !*** ./src/js/modules/search.js ***!
  \**********************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

eval("__webpack_require__.r(__webpack_exports__);\nconst enableSearch = () => {\n\tconst searchInput = document.querySelector('#search-input')\n\tconst searchBtn = document.querySelector('#search-btn')\n\n\tenableSearchElements()\n\n\tsearchBtn.addEventListener('click', implementSearch)\n\n\tsearchInput.addEventListener('input', () => {\n\t\tif (searchInput.value.trim() === '') {\n\t\t\timplementSearch()\n\t\t}\n\t})\n\n\tdocument.addEventListener('keydown', event => {\n\t\tif (event.code === 'Enter') {\n\t\t\tevent.preventDefault()\n\t\t\timplementSearch()\n\t\t}\n\t})\n}\n\nfunction implementSearch() {\n\tconst searchInput = document.querySelector('#search-input')\n\tconst doctorOption = document.querySelector('#dropdownMenuDoctors')\n\tconst statusOption = document.querySelector('#dropdownMenuStates')\n\tconst allVisitCards = document.querySelectorAll('.item')\n\tconst allClientNameElements = document.querySelectorAll('.item__name')\n\tconst visitsContainer = document.querySelector('.desk__items-container')\n\tconst noVisitsElement = visitsContainer.querySelector('.no-visits')\n\n\tif(noVisitsElement){noVisitsElement.remove()}\n\n\tallClientNameElements.forEach(clientNameElement => clientNameElement.innerHTML = clientNameElement.innerText)\n\tallVisitCards.forEach(visitCard => visitCard.closest('.col').classList.add('card-hidden'))\n\n\tconst filteredByName = Array.from(allVisitCards).filter(visitCard => {\n\t\tconst clientNameElement = visitCard.querySelector('.item__name')\n\t\tconst clientNameElementValue = clientNameElement.innerText.toLowerCase()\n\t\tconst searchInputValue = searchInput.value.toLowerCase().trim()\n\n\t\tif (searchInputValue === '') { return visitCard }\n\n\t\tif (clientNameElementValue.search(searchInputValue) !== -1) {\n\t\t\tlet str = clientNameElement.innerText\n\t\t\tclientNameElement.innerHTML = insertMark(str, clientNameElementValue.search(searchInputValue), searchInputValue.length)\n\t\t\treturn visitCard\n\t\t}\n\t})\n\n\tconst filteredByDoctor = filteredByName.filter(el => {\n\t\tconst selectedDoctor = doctorOption.innerText\n\t\tif (selectedDoctor === 'All doctors') { return el }\n\t\treturn el.dataset.doctor === selectedDoctor\n\t})\n\n\tconst filteredByStatus = filteredByDoctor.filter(el => {\n\t\tconst selectedString = statusOption.innerText\n\t\tconst selectedStatus = selectedString.slice(selectedString.indexOf(' ')+1).toLowerCase()\n\t\tif (selectedStatus === 'all') { return el }\n\t\treturn el.dataset.status === selectedStatus\n\t})\n\n\tif(filteredByStatus.length === 0){\n\t\tconst noVisitsFound = document.createElement('div')\n\t\tnoVisitsFound.classList.add('no-visits')\n\t\tnoVisitsFound.innerText = 'No visits have been found'\n\t\tvisitsContainer.append(noVisitsFound)\n\t}\n\n\tfilteredByStatus.forEach(el => {\n\t\tel.closest('.col').classList.remove('card-hidden')\n\t})\n}\n\nfunction insertMark(str, position, length) {\n\treturn str.slice(0, position) + '<mark class=\"search-mark\">' + str.slice(position, position + length) + '</mark>' + str.slice(position + length)\n}\n\nfunction enableSearchElements() {\n\tconst allDisabled = document.querySelectorAll('[disabled=true]')\n\tallDisabled.forEach(el => el.disabled = false)\n}\n\n/* harmony default export */ __webpack_exports__[\"default\"] = (enableSearch);\n\n//# sourceURL=webpack://step_project_cards/./src/js/modules/search.js?");

/***/ }),

/***/ "./src/js/modules/visit.js":
/*!*********************************!*\
  !*** ./src/js/modules/visit.js ***!
  \*********************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _element__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./element */ \"./src/js/modules/element.js\");\n\n\n\nclass Visit extends _element__WEBPACK_IMPORTED_MODULE_0__[\"default\"] {\n    constructor({\n        id,\n        name,\n        doctor,\n        description,\n        problem,\n        age,\n        lastVisit,\n        pressure,\n        lastPressure,\n        status = \"Open\",\n    }) {\n        super();\n        this.name = name;\n        this.description = description;\n        this.problem = problem;\n        this.age = age;\n        this.lastVisit = lastVisit;\n        this.pressure = pressure;\n        this.lastPressure = lastPressure;\n        this.doctor = doctor;\n        this.status = status.toLowerCase();\n        this.id = id;\n        this.container = document.querySelector(\".desk__items-container\");\n    }\n\n    createCard() {\n        this.item = this.createElement(\"div\", [\"item\"]);\n        this.wrapper = this.createElement(\"div\", [\"col\", \"remove-padding\"]);\n        this.item.setAttribute(\"data-id\", this.id);\n        this.item.dataset.doctor = this.doctor;\n        this.item.dataset.status = this.status;\n        this.item.innerHTML = `\n    <div class=\"item__container\">\n        <div class=\"item__content\">\n            <h3 class=\"item__name\">${this.name}</h3>\n            <p class=\"item__doctor\">Doctor's appointment: <span>${\n                this.doctor\n            }</span></p>\n            <p class=\"item__status\">Status: ${this.checkedStatus()}</p>\n            <div class=\"content-extra\">\n                <p class=\"content-extra__problem\">${\n                    this.problem ? this.problem : \"\"\n                }</p>\n                <p class=\"content-extra__description\">${\n                    this.description ? this.description : \"\"\n                }</p>\n                ${this.extraContent()}\n            </div>\n        </div>\n        <div class=\"item__buttons\">\n            <button class=\"button-delete\" data-del=\"delete\"></button>\n            <button class=\"button-moreInfo\" data-moreInfo=\"moreInfo\" data-bs-toggle=\"modal\" data-bs-target=\"#exampleModal\">More info</button>\n            <button class=\"button-edit\" data-edit=\"edit\" data-bs-toggle=\"modal\" data-bs-target=\"#exampleModal\">Edit</button>\n        </div>\n    </div>\n    `;\n        this.wrapper.prepend(this.item);\n        this.container.prepend(this.wrapper);\n    }\n    checkedStatus() {\n        this.blockInner = \"\";\n        if (this.status === \"open\") {\n            this.blockInner = `<span class=\"status-green\">Open</span>`;\n            this.item.classList.remove(\"status-done\");\n        } else {\n            this.blockInner = `<span class=\"status-red\">Done</span>`;\n            this.item.classList.add(\"status-done\");\n        }\n        return this.blockInner;\n    }\n    extraContent() {\n        if (this.doctor === \"Dentist\") {\n            const dentist = new VisitDentist();\n            return dentist.renderVisit(this.lastVisit);\n        }\n        if (this.doctor === \"Cardiologist\") {\n            const cardiologist = new VisitCardiologist();\n            return cardiologist.renderVisit(\n                this.age,\n                this.pressure,\n                this.lastPressure\n            );\n        }\n        if (this.doctor === \"Physician\") {\n            const physician = new VisitPhysician();\n            return physician.renderVisit(this.age);\n        }\n        return \"\";\n    }\n}\n\nclass VisitDentist {\n    constructor() {}\n    renderVisit(lastVisit) {\n        return `<p class=\"content-extra__lastVisit\">${lastVisit}</p>`;\n    }\n}\nclass VisitCardiologist {\n    constructor() {}\n    renderVisit(age, pressure, lastPressure) {\n        return `<p class=\"content-extra__pressure\">${pressure}</p>\n              <p class=\"content-extra__lastPressure\">${lastPressure}</p>\n              <p class=\"content-extra__age\">${age}</p>`;\n    }\n}\nclass VisitPhysician {\n    constructor() {}\n    renderVisit(age) {\n        return `<p class=\"content-extra__age\">${age}</p>`;\n    }\n}\n\n/* harmony default export */ __webpack_exports__[\"default\"] = (Visit);\n\n\n//# sourceURL=webpack://step_project_cards/./src/js/modules/visit.js?");

/***/ }),

/***/ "./src/js/modules/visitModal.js":
/*!**************************************!*\
  !*** ./src/js/modules/visitModal.js ***!
  \**************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _modal__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./modal */ \"./src/js/modules/modal.js\");\n/* harmony import */ var _changeDropdownValue__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./changeDropdownValue */ \"./src/js/modules/changeDropdownValue.js\");\n/* harmony import */ var _request__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./request */ \"./src/js/modules/request.js\");\n/* harmony import */ var _logInModal__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./logInModal */ \"./src/js/modules/logInModal.js\");\n\n\n\n\n\nclass VisitModal extends _modal__WEBPACK_IMPORTED_MODULE_0__[\"default\"] {\n    constructor(modalName) {\n        super(modalName);\n        this.modalName = modalName;\n    }\n    render({\n        name,\n        status,\n        doctor,\n        problem,\n        id,\n        description,\n        lastVisit,\n        pressure,\n        lastPressure,\n        age,\n    } = {}) {\n        const modalTitle = document.querySelector(\"#exampleModalLabel\");\n        const modalBtn = document.querySelector(\".form__submit-bnt\");\n        modalTitle.textContent = `${this.modalName}`;\n        modalBtn.textContent = `${this.modalName}`;\n\n        const modalBody = document.querySelector(\".form__body\");\n        const modalDialog = document.querySelector(\"#exampleModal\");\n        const closeBtn = document.querySelector(\".form__btn-close\");\n        const modalHTML = `<div class=\"dropdown form__input visit-modal\" data-id=\"${id}\">\n        <button class=\"dropdown-toggle\" type=\"button\" \n        id=\"visitModalDropdownMenuDoctors\" data-bs-toggle=\"dropdown\" \n        data-bs-auto-close=\"true\" aria-expanded=\"false\">\n            ${doctor ? doctor : \"Choose a doctor\"}\n        </button>\n        <ul class=\"dropdown-menu options__dropdown-menu\" \n        aria-labelledby=\"visitModalDropdownMenuDoctors\">\n            <li>\n                <a class=\"options__dropdown-item form__dropbox-item dropdown-item\" href=\"#\">Cardiologist</a>\n            </li>\n            <li>\n                <a class=\"options__dropdown-item form__dropbox-item dropdown-item\" href=\"#\">Dentist</a>\n            </li>\n            <li>\n                <a class=\"options__dropdown-item form__dropbox-item dropdown-item\" href=\"#\">Physician</a>\n            </li>\n        </ul>\n    </div>\n    <input\n            type=\"text\"\n            name=\"purpose\"\n            class=\"form__input\"\n            placeholder=\"The purpose of visit\"\n            id=\"userProblem\"\n            value=\"${problem ? problem : \"\"}\"\n        />\n        <textarea class=\"form__input\" \n        placeholder=\"Short description\"\n        id=\"userDescription\"\n        rows=\"3\">${description ? description : \"\"}</textarea>\n        <input\n            type=\"text\"\n            name=\"name\"\n            class=\"form__input\"\n            placeholder=\"Name, Surname\"\n            id=\"userName\"\n            value=\"${name ? name : \"\"}\"\n        />\n        ${status ? this.checkVisitStatus(status) : \"\"}`;\n        modalBody.insertAdjacentHTML(\"beforeend\", modalHTML);\n\n        const statusBtn = document.querySelector(\"#status-btn\");\n        const selectItemsArray = document.querySelectorAll(\n            \".visit-modal .options__dropdown-item\"\n        );\n        (0,_changeDropdownValue__WEBPACK_IMPORTED_MODULE_1__[\"default\"])(selectItemsArray, true, doctor, {\n            lastVisit,\n            pressure,\n            lastPressure,\n            age,\n        });\n        closeBtn.addEventListener(\"click\", this.hideModal);\n\n        if (statusBtn) {\n            statusBtn.addEventListener(\"click\", () => {\n                if (statusBtn.dataset.status === \"Open\") {\n                    statusBtn.classList.remove(\"form__status-btn--green\");\n                    statusBtn.classList.add(\"form__status-btn--red\");\n                    statusBtn.textContent = \"Status: Done\";\n                    statusBtn.dataset.status = \"Done\";\n                } else {\n                    statusBtn.classList.remove(\"form__status-btn--red\");\n                    statusBtn.classList.add(\"form__status-btn--green\");\n                    statusBtn.textContent = \"Status: Open\";\n                    statusBtn.dataset.status = \"Open\";\n                }\n            });\n        }\n        modalDialog.addEventListener(\"click\", (e) => {\n            const item = e.target;\n            try {\n                if (item.id === \"exampleModal\") {\n                    this.hideModal();\n                } else if (\n                    item.innerText === \"Create visit\" &&\n                    item.localName === \"button\"\n                ) {\n                    if (this.checkInputsValue()) {\n                        return;\n                    }\n                    this.sendRequest(\"POST\");\n                } else if (\n                    item.innerText === \"Edit\" &&\n                    item.localName === \"button\"\n                ) {\n                    if (this.checkInputsValue()) {\n                        return;\n                    }\n                    const currentId = document.querySelector(\".visit-modal\");\n                    this.sendRequest(\n                        \"PUT\",\n                        statusBtn.dataset.status,\n                        currentId.dataset.id\n                    );\n                }\n            } catch (error) {\n                const selectDoctors = document.querySelector(\n                    \"#visitModalDropdownMenuDoctors\"\n                );\n                selectDoctors.style.borderColor = \"red\";\n            }\n        });\n    }\n    hideModal() {\n        super.hideModal();\n        super.clearInputs();\n        super.render();\n    }\n    checkVisitStatus(status) {\n        if (status === \"Open\") {\n            return `<button class=\"form__input form__status-btn form__status-btn--green\" id=\"status-btn\" data-status=\"Open\">Status: Open</button>`;\n        } else if (status === \"Done\") {\n            return `<button class=\"form__input form__status-btn form__status-btn--red\" id=\"status-btn\" data-status=\"Done\">Status: Done</button>`;\n        }\n    }\n    repeatValues() {\n        this.wrapper = document.body.querySelector(\".modal-content\");\n        this.userProblem = this.wrapper.querySelector(\"#userProblem\").value;\n        this.userDescription =\n            this.wrapper.querySelector(\"#userDescription\").value;\n        this.userName = this.wrapper.querySelector(\"#userName\").value;\n        this.userDoctor = document.getElementById(\n            \"visitModalDropdownMenuDoctors\"\n        ).innerText;\n    }\n    takeValuesInput() {\n        this.repeatValues();\n        if (this.userDoctor === \"Dentist\") {\n            this.userLastVisit =\n                this.wrapper.querySelector(\"#userLastVisit\").value;\n            return {\n                name: this.userName,\n                problem: this.userProblem,\n                description: this.userDescription,\n                doctor: this.userDoctor,\n                status: \"Open\",\n                lastVisit: this.userLastVisit,\n            };\n        } else if (this.userDoctor === \"Cardiologist\") {\n            this.userPressure =\n                this.wrapper.querySelector(\"#userPressure\").value;\n            this.userLastPressure =\n                this.wrapper.querySelector(\"#userLastPressure\").value;\n            this.userAge = this.wrapper.querySelector(\"#userAge\").value;\n            return {\n                name: this.userName,\n                problem: this.userProblem,\n                description: this.userDescription,\n                doctor: this.userDoctor,\n                status: \"Open\",\n                pressure: this.userPressure,\n                lastPressure: this.userLastPressure,\n                age: this.userAge,\n            };\n        } else if (this.userDoctor === \"Physician\") {\n            this.userAge = this.wrapper.querySelector(\"#userAge\").value;\n            return {\n                name: this.userName,\n                problem: this.userProblem,\n                description: this.userDescription,\n                doctor: this.userDoctor,\n                status: \"Open\",\n                age: this.userAge,\n            };\n        }\n    }\n    sendRequest(sendMethod, sendStatus, sendId) {\n        const url = \"https://ajax.test-danit.com/api/v2/cards\";\n        const urlPut = `https://ajax.test-danit.com/api/v2/cards/${sendId}`;\n        const {\n            name,\n            status,\n            doctor,\n            problem,\n            description,\n            lastVisit,\n            pressure,\n            lastPressure,\n            age,\n        } = this.takeValuesInput();\n        if (doctor === \"Dentist\") {\n            (0,_request__WEBPACK_IMPORTED_MODULE_2__[\"default\"])({\n                url: sendMethod === \"PUT\" ? urlPut : url,\n                data: {\n                    name,\n                    status: sendStatus ? sendStatus : status,\n                    doctor,\n                    problem,\n                    description,\n                    lastVisit,\n                },\n                options: { method: `${sendMethod}` },\n            });\n        }\n        if (doctor === \"Cardiologist\") {\n            (0,_request__WEBPACK_IMPORTED_MODULE_2__[\"default\"])({\n                url: sendMethod === \"PUT\" ? urlPut : url,\n                data: {\n                    name,\n                    status: sendStatus ? sendStatus : status,\n                    doctor,\n                    problem,\n                    description,\n                    pressure,\n                    lastPressure,\n                    age,\n                },\n                options: { method: `${sendMethod}` },\n            });\n        }\n        if (doctor === \"Physician\") {\n            (0,_request__WEBPACK_IMPORTED_MODULE_2__[\"default\"])({\n                url: sendMethod === \"PUT\" ? urlPut : url,\n                data: {\n                    name,\n                    status: sendStatus ? sendStatus : status,\n                    doctor,\n                    problem,\n                    description,\n                    age,\n                },\n                options: { method: `${sendMethod}` },\n            });\n        }\n        const deskContainer = document.querySelector(\".desk__items-container\");\n        deskContainer.innerHTML = \"\";\n        this.hideModal();\n        setTimeout(() => {\n            (0,_logInModal__WEBPACK_IMPORTED_MODULE_3__.loadPatients)();\n        }, 200);\n    }\n    checkInputsValue() {\n        const inputs = document.querySelectorAll(\".form__input\");\n        let flag = false;\n        inputs.forEach((e) => {\n            if (e.value === \"\" && e.id !== \"status-btn\") {\n                e.style.borderColor = \"red\";\n                flag = true;\n            }\n        });\n        return flag;\n    }\n}\n/* harmony default export */ __webpack_exports__[\"default\"] = (VisitModal);\n\n\n//# sourceURL=webpack://step_project_cards/./src/js/modules/visitModal.js?");

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/define property getters */
/******/ 	!function() {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = function(exports, definition) {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	!function() {
/******/ 		__webpack_require__.o = function(obj, prop) { return Object.prototype.hasOwnProperty.call(obj, prop); }
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	!function() {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = function(exports) {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	}();
/******/ 	
/************************************************************************/
/******/ 	
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	// This entry module can't be inlined because the eval devtool is used.
/******/ 	var __webpack_exports__ = __webpack_require__("./src/js/index.js");
/******/ 	
/******/ })()
;